#
#clear

netcls=$1

if [ -f "/var/brainycp/license" ]; then
  echo -e "\033[1;31m The panel is already installed. Re-installation is detrimental to the system!!!\033[0m\n\n";tput sgr0
  exit 1
fi

echo ""
echo "WARNING!"
echo "If you are a CONTABO client. Please, read this post before continuing: https://community.brainycp.com/viewtopic.php?f=9&t=4004"
echo "Press CTRL+C to abort the installation."
echo ""
echo "if not, or is already fixed, press Enter to continue..."
read -s -n 1

## CHECKING UPDATE SYSTEM
echo -e "System update checking, please wait... "
echo -ne '                          (0%)\r'
yum -y remove epel-release  &>/dev/null
yum -y remove epel*  &>/dev/null
yum -y remove epel-*  &>/dev/null
yum clean all &>/dev/null
echo -ne '#                         (10%)\r'
#
# System Update Packages
#yum clean all &>/dev/null
yum -y module disable nginx php httpd mysql &>/module.log
yum -y module disable nodejs &>>/module.log
echo -ne '##                        (12%)\r'
yum -y install audit-libs audit &>>/module.log
echo -ne '###                       (15%)\r'
yum -y install rpm python3-rpm rpm-build-libs rpm-libs &>/var/log/brainy_update.log
echo -ne '####                      (20%)\r'
yum -y install kernel &>>/var/log/brainy_update.log
echo -ne '#####                     (30%)\r'
yum -y install systemd &>>/var/log/brainy_update.log
echo -ne '#######                   (40%)\r'
yum -y install glibc &>>/var/log/brainy_update.log
echo -ne '########                  (50%)\r'
yum -y install python3 &>>/var/log/brainy_update.log
echo -ne '#########                 (60%)\r'
yum -y install perl &>>/var/log/brainy_update.log
echo -ne '############              (70%)\r'
yum -y install boost &>>/var/log/brainy_update.log
echo -ne '###############           (80%)\r'
yum -y install nss &>>/var/log/brainy_update.log
echo -ne '###################       (90%)\r'
yum -y remove mariadb-libs &>/dev/null
echo -ne '######################    (95%)\r'

## DEBUG
#echo "Centos 8 is in the test only. Officially, it is not yet supported. Press any key to continue..."
#read -s -n 1

#
# VIRT TYPE
#
yum install -y centos-linux-repos &>/dev/null
echo -ne '######################### (97%)\r'
yum -y install virt-what dmidecode &>/dev/null
echo -e '##########################(100%)\r'

sed -i '/\[appstream\]/c\[AppStream\]' /etc/yum.repos.d/CentOS-Linux-AppStream.repo &>/dev/null
sed -i '/\[baseos\]/c\[BaseOS\]' /etc/yum.repos.d/CentOS-Linux-BaseOS.repo &>/dev/null

# oom_killer
# oom_killer
sysctl -e -w vm.oom_kill_allocating_task=1 &>/dev/null
echo "vm.oom_kill_allocating_task=1" >> /etc/sysctl.conf &>/dev/null
sysctl -p &>/dev/null

# Set SYSTEMD default
sed -i "/#DefaultMemoryAccounting=/cDefaultMemoryAccounting=yes" /etc/systemd/system.conf &> /dev/null
sed -i "/#DefaultCPUAccounting=/cDefaultCPUAccounting=yes" /etc/systemd/system.conf &> /dev/null

echo -en "\033[1;32m[DONE] \033[0m\n";tput sgr0
##DONE

#
function get_server_virt_type() {
    virtall="$(virt-what)"
    virttypez="$(dmidecode -s system-product-name 2>/dev/stdout| awk '{print $1}')"
    virttypexen="$(dmidecode | grep -i domU 2>/dev/stdout)"
    virttypemic="$(dmidecode | egrep -i 'manufacturer|product' 2>/dev/stdout)"

    if [[ $virtall = *"xen"* ]]; then
	virttype="xen"
    elif [[ $virtall = "lxc" ]];then
	virttype="xlc"
    elif [[ $virttypemic = "Product Name: HVM domU" ]];then
	virttype="microsoftvirtpc"
    elif [[ $virttypexen = "Product Name: HVM domU" ]];then
	virttype="xen"
    elif [[ $virttypez = "/dev/mem:" ]];then
	virttype="openvz"
    elif [[ $virttypez = "KVM" ]];then
	virttype="kvm"
    elif [[ $virttypez = "VMware" ]];then
	virttype="wmware"
    elif [[ $virttypez = "VirtualBox" ]];then
	virttype="virtualbox"
    elif [[ $virttypez = "Bochs" ]];then
	virttype="Bochs"
    else 
	virttype="baremetal"
    fi

    echo $virttype
}
#
# END VIRT TYPE
#

echo ""
echo "Type Script: KVM"

echo -en "Install tools network...  "
yum -y install net-tools &>/var/log/brainy_tools.log
if [ $? -eq 0 ]; then
    echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0
else
    echo -e "\033[1;31m [ERROR] \033[0m\n";tput sgr0
    echo "More details /var/log/brainy_tools.log\n"
    l=`cat /var/log/brainy_tools.log`
    echo $l
    exit
fi

arch_ver=`uname -m`
if [[ $arch_ver != 'x86_64' ]];then
#if [[ $arch_ver != 'i686' ]];then
    echo -e "\033[1;31mSorry. Your systems is not supported. x86_64 only.\033[0m\n"
    tput sgr0
    exit 0
#fi
fi

REPO_ARRD="http://185.53.160.221"

echo -e ""
echo -e "======= Install BRAINY ISP panel ========"
echo -e ""

if [ "$netcls" == "network" ];then
    echo -e "Disable ISP network configure"
else
gw=`route -n | grep UG | awk '{print $2}'|xargs`
ifdev=`route -n | grep UG | awk '{print $8}'|xargs`

if [[ "$gw" == 169.254.* ]];then
echo "Detected Anaconda interface"
/bin/rm -f /etc/sysconfig/network-scripts/ifcfg-$ifdev:1 &>/dev/null

cat <<EOF>> /etc/sysconfig/network-scripts/ifcfg-$ifdev:1
BOOTPROTO=static
DEVICE=$ifdev:1
ONBOOT=yes
IPADDR=169.254.0.142
PREFIX=16
GATEWAY=$gw
EOF
fi

s1=`systemctl list-units -t service --all | grep active | grep -v inactive | grep network.service |  awk '{print $1}'`
s2=`systemctl list-units -t service --all | grep active | grep -v inactive | grep NetworkManager.service |  awk '{print $1}'`
if [ ! -z $s1 ] && [ ! -z $s2 ];then
    net_service='NT'
    systemctl stop $s2
else
    net_service='NM'
fi

fi


#echo "nameserver 8.8.8.8" >> /etc/resolv.conf
network=''
ver=`cat /etc/redhat-release | grep -Eo '[0-9]' | awk '{print $1}' | head -n1`
if [[ $ver == 7 ]];then
    if [ -f "/lib/systemd/system/NetworkManager.service" ];then
	network=`systemctl status NetworkManager | grep inactive`
    else
	network='Service inactive'
    fi
fi

while getopts v:a:s:p:-setup::-package::-version::-action:: option; do
 case "${option}"
 in
	v|--version) VERSION_BUILD=$(echo ${OPTARG} | grep -Eoi '[a-z0-9\.\-]+$');;
	a|--action) ACTION=$(echo ${OPTARG} | grep -Eoi '[a-z0-9\.\-]+$');;
	s|--setup) setup="-s=$(echo ${OPTARG} | grep -E -o '[a-z]+$')";;
	p|--package) package="-p=$(echo ${OPTARG} | grep -E -o -i '([a-z0-9\.\-]+,?)+$')";;
 esac
done

if [ $(free | grep Mem: | awk '{print $2}' |grep -Eo '^[0-9]+') -lt "2102294" ]; then
	if [ -z $setup ]; then
		if [ -z $package ]; then
			setup='-s=min'
		else
			setup=$package
		fi
	else
		setup=$setup
	fi
else
	if [ -z $setup ]; then
		if [[ -n $package ]]; then
			setup=$package
		fi
	else
		setup=$setup
	fi
fi

if [[ $(echo $setup |grep -Eo '[a-z]+$') = "min" ]]; then
	echo -e "======= Setup minimal configuration ========"
else
	if [ -z $(echo $setup |grep '\-p') ]; then
		echo -e "======= Setup maximum configuration ========"
	else
		echo -e "======= Setup \" $(echo $setup |grep -Eoi '([a-z0-9\.\-]+,?)+$')\" ========"
	fi
fi

/bin/rm -f /etc/yum.repos.d/epel.repo &>/dev/null

echo -en "Configure process download... "
#yum install -y wget &>/dev/null
yum install -y wget &>./conf_error.log
if [ $? -eq 0 ]; then
    echo -en "\033[1;32m [OK] \033[0m\n"
    tput sgr0
else
    echo -e "\033[1;31m [ERROR] \033[0m\n"
    tput sgr0
    exit
fi

mkdir -p "/var/tmp0/brainyf"
echo -en "Download version... "
wget http://core.brainycp.com/version.txt -P "/var/tmp0/brainyf" &>/dev/null
if [ $? -eq 0 ]; then
    echo -en "\033[1;32m [OK] \033[0m\n"
    tput sgr0
else
    echo -e "\033[1;31m Download version problems! [ERROR] \033[0m\n"
    tput sgr0
    exit
fi


panel_ver=`cat "/var/tmp0/brainyf/version.txt" | awk -F "=" '/current_version/{print $2}'`
/bin/rm -f /var/tmp0/brainyf/version.txt


#####
#  TEST VERSION 1.09
#
if [ $(printf "%s" "$VERSION_BUILD"|| wc -c) > 1 ]; then
panel_ver=$VERSION_BUILD
fi

panel_ver="1.09"
echo ""
echo "*******  BRAINYCP PANEL VERSION $panel_ver  ********"

#
#
##### END


function validate_url(){
  if [[ `wget -S --spider $1  2>&1 | grep -E 'HTTP/1\.(0|1)+ 200 OK'` ]]; then
	echo "true";
  else
	echo "false";
  fi
}

url_det=http://core.brainycp.com/stable/dev_arch/$panel_ver/latest.tar.gz;
check_exist=$(validate_url $url_det);
if [ "$check_exist" == "false" ]; then
 echo "Selected version $panel_ver doesn't exist" ;
 exit 1;
fi

echo -e "Install BrainyCP version $panel_ver \n"
echo $ACTION


setdate="`wget -qO- http://core.brainycp.ru/date.php`" ; date --set="$setdate"

ver=`cat /etc/redhat-release | grep -Eo '[0-9]' | awk '{print $1}' | head -n1`
get_osname=`cat /etc/redhat-release | awk '{print tolower($1)}'`

if [ "$ACTION" == "updatefilesonly" ]; then
	echo -e "Run update..."
    if [ "$get_osname" == "centos" ]; then
    	if [ "$ver" == "6" ]; then
	        service brainy stop
	    fi
    	if [ "$ver" == "7" ]; then
	        systemctl stop brainy
	    fi
	fi
	sleep 3

    mkdir -p "/var/tmp0/brainyf"
    cd /var/tmp0/brainyf/
    wget http://core.brainycp.com/stable/dev_arch/$panel_ver/latest.tar.gz -P "/var/tmp0/brainyf"

    echo -e "\nExtracting files..."
    tar xf /var/tmp0/brainyf/latest.tar.gz
    /bin/rm -f /var/tmp0/brainyf/latest.tar.gz

    file="/var/tmp0/brainyf/.gitignore"
    exs1="--exclude='/var/tmp0/brainyf/"
    find="/\*"
    replace=""
    find1="//"
    replace1="/"
    echo -e "\nPreparing files..."
    while read line
    do
        line=${line/$find/$replace}
        excl="$excl$exs1$line' "
        excl=${excl/$find1/$replace1}
    done < $file
    sd="tar $excl -cf /etc/brainy/brainy_files_upd.tgz /var/tmp0/brainyf" 2>/dev/null
    eval $sd

    while read line
    do
        if [[ "$line" == "!"* ]]; then
            temp=$(echo "$line" | sed 's/!//g')
            sd="tar -rvf /etc/brainy/brainy_files_upd.tgz /var/tmp0/brainyf$temp"
            eval $sd
        fi
    done < $file

    echo -e "\nUpdating files..."

    tar xf  /etc/brainy/brainy_files_upd.tgz -C /etc/brainy 2>/dev/null
    /bin/rm -rf /etc/brainy/brainy_files_upd.tgz

    yes | cp -rf /etc/brainy/tmp/brainyf/* /etc/brainy/ 2>/dev/null
    yes | cp -rf /etc/brainy/tmp/brainyf/{.,} /etc/brainy/ 2>/dev/null
    chown -R root.root /etc/brainy
    rm -rf /etc/brainy/tmp/brainyf
    rm -f /etc/brainy/.gitignore
    rm -rf /var/tmp0/brainyf/

    if [ "$get_osname" == "centos" ]; then
    	if [ "$ver" == "6" ]; then
	        service brainy start
	    fi
    	if [ "$ver" == "7" ]; then
	        systemctl start brainy
	    fi
	fi

	echo -e "\n\nBrainyCP was successfully updated\n"
	exit 1
fi
##
## end updates
##

echo -en "Disable SELINUX...\t"
if [ "$get_osname" == "centos" ]; then
    sed -i "/SELINUX=enforcing/cSELINUX=disabled" /etc/sysconfig/selinux &> /dev/null
    sed -i "/SELINUX=enforcing/cSELINUX=disabled" /etc/selinux/config &> /dev/null
    if [ $ver = 8 ];then
        setenforce 0 &> /dev/null
    else
        echo 0 > /selinux/enforce
    fi
fi
echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0

#echo -en "Prepare install...\t"
#yum -y install net-tools &>/dev/null


function valid_ip()
{
    local  ip=$1
    local  stat=1

    if [[ $ip =~ ^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$ ]]; then
        OIFS=$IFS
        IFS='.'
        ip=($ip)
        IFS=$OIFS
        [[ ${ip[0]} -le 255 && ${ip[1]} -le 255 \
            && ${ip[2]} -le 255 && ${ip[3]} -le 255 ]]
        stat=$?
    fi
    return $stat
}

function get_ip_server {
    ip_get="`wget -qO- http://core.brainycp.ru/ipchecker.php`"
    if valid_ip $ip_get; then
        echo $ip_get
    else
        ipaddr=$(hostname -I)
        for word in $ipaddr
            do
            if [ $word != "127.0.0.1" ]; then
                echo $word
                break
            fi
            done
    fi
}


#
#
#
echo -en "Prepare install...\t"
yum -y install net-tools &>/dev/null
if [ $? -eq 0 ]; then
		result=0
		echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0
else
		result=1
		echo -e "\033[1;31m [ERROR] \033[0m\n";tput sgr0;exit
fi

check_hostname=$(hostname | grep -E "^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9])$")
size_host=${#check_hostname}

### "

get_osname=`cat /etc/redhat-release | awk '{print tolower($1)}'`
get_osver=`cat /etc/redhat-release | grep -oE '[0-9.]'| sed ':a;N;$!ba;s/\n//g' | cut -c 1`

#if [ "$get_osname" == "centos" ]; then
#	needrepo[0]="*Base*"
#	needrepo[1]="*base*"
#	needrepo[2]="*updates*"
#	needrepo[2]="*Updates*"
#	mkdir -p /var/tmp0/brainy_repos
#	mv /etc/yum.repos.d/* /var/tmp0/brainy_repos/  &>/dev/null
#	for i in "${needrepo[@]}"
#	do
#		mv /var/tmp0/brainy_repos/$i /etc/yum.repos.d/ &>/dev/null
#	done
#fi

# [ ${get_osver:0:1} != 6 ]
# then
# printf "\nSorry. Supported only by CentOs 6.\n"
# exit 1
# fi

yum erase -y ssmtp &>/dev/null

if [ $size_host == 0 ] || [ $check_hostname == 'localhost' ]
then
	hostname brainycp-install.localhost
	#ip_serv=$(ifconfig | grep 'inet addr:'| grep -v '127.0.0.1' | cut -d: -f2 | awk '{ print $1}' | head -1)
	ip_serv=$(get_ip_server)
	sed -i "$ a $ip_serv brainycp-install.localhost" /etc/hosts
fi

##
## Remove old packages
##
rpm -e repo-brainy &>/dev/null
#rpm -qa | grep postfix | xargs rpm -e --nodeps   &>/dev/null
yum remove -y postfix &>/dev/null
yum remove -y libjpeg-turbo.i686 &>/dev/null
yum remove -y ruby ruby* &>/dev/null
yum remove -y libselinux-ruby &>/dev/null
yum remove -y numactl-libs.i686 &>/dev/null


##
## Install repo
##
yum clean all &>/dev/null

##
## Reconfigure SSHPASS
##

echo -en "Configure repo... "
mkdir -p "/var/log/brainy"
if [ $arch_ver == 'i686' ];then
	yum remove ImageMagick -y &>/dev/null
	rpm -Uv --replacepkgs http://repo.brainycp.com/centos/repo/repo-brainy-v3-8.0-1.el8.noarch.rpm &>/dev/null
else
	yum install ImageMagick -y &>/var/log/brainy/install_repo.log
	rpm -Uv --replacepkgs http://brainyrepo1.brainycp.com/centos/repo/repo-brainy-v3-8.0-1.el8.noarch.rpm &>>/var/log/brainy/install_repo.log
fi
if [ $? -eq 0 ]; then
		result=0
		echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0
else
		result=1
		echo -e "\033[1;31m [ERROR] \033[0m\n";tput sgr0;
		echo -e "More details /var/log/brainy/install_repo.log"
		exit
fi
rpm -Uv --install http://brainyrepo1.brainycp.com/centos/repo/repo-brainy-v3-8.0-1.el8.noarch.rpm  &>>/var/log/brainy/install_repo.log
yum clean all &>/dev/null

ver=`cat /etc/redhat-release | grep -Eo '[0-9]' | awk '{print $1}' | head -n1`
echo -e "Version os: $ver"
echo -e "Architecture os: $arch_ver \n"

### configure limit
paml=`rpm -qa | grep pam-1 | wc -l`
#if [ $paml == '1' ];then
#echo -en "Configure limits... "
#fi

echo -en "Configure limits... "
#paml=`rpm -qa | grep pam | cut -d"-" -f1 |xargs`
#if [ "$panl" == "pam" ];then
    echo "* hard    nproc           50000" >> /etc/security/limits.conf
    echo "* soft    nproc           50000" >> /etc/security/limits.conf
    echo "* soft nofile 200000" >> /etc/security/limits.conf
    echo "* hard nofile 200000" >> /etc/security/limits.conf
#else
#    yum -y install pam  &>>/install_0.log
#    if [ $? -eq 0 ]; then
#	echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0
#    else
#	echo -e "\033[1;31m [ERROR] \033[0m\n";tput sgr0;exit
#    fi
#fi

#echo "session required /lib64/security/pam_limits.so" >> /etc/pam.d/login
ulimit -n 35000
echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0

#
#  Huge Pages
#
echo -en "Update THP Memory...  "
echo never > /sys/kernel/mm/transparent_hugepage/enabled
echo never > /sys/kernel/mm/transparent_hugepage/defrag
sysctl -e -w vm.nr_hugepages=20 &>/dev/null
echo "vm.nr_hugepages=20" >> /etc/sysctl.conf
sysctl -p &>/dev/null
yum install -y hugepages &>/dev/null
systemctl start transparent-huge-pages.service &>/dev/null
systemctl enable transparent-huge-pages.service &>/dev/null
echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0

#
# Configure network
#
if [ "$netcls" != "network" ];then
echo -en "Configure network... "
yum -y install NetworkManager NetworkManager-tui NetworkManager-wifi NetworkManager-team &>>/install_0.log
if [ $? -eq 0 ]; then
    echo -en "\033[1;32m [OK] \033[0m\n"
    tput sgr0
else
    echo -e "\033[1;31m [ERROR] \033[0m\n"
    echo -e "More details: cat /install_0.log"
    tput sgr0
    exit
fi
fi


## DEBUG
#echo "Debug Mode[prepare install]. Press any key to continue."
#read -s -n 1

echo "Run install script."
rpm -e --nodeps mariadb-libs   &>>/install_0.log
rpm -qa | grep bind | xargs rpm -e --nodeps  &>>/install_0.log
rpm -qa | grep maria | xargs rpm -e --nodeps  &>>/install_0.log
rpm -qa | grep postgresql | xargs rpm -e --nodeps  &>>/install_0.log
rpm -qa | grep libwebp | xargs rpm -e --nodeps  &>>/install_0.log
rm -rf /usr/lib64/mysql &>>/install_0.log

if [ $ver = 8 ];then
    yum install -y --disablerepo=* --enablerepo=myrepo-centos,8_sql,8_app mariadb-libs &>/install_libs.log
    yum install -y perl-DBI &>>/install_libs.log
    yum install -y --disablerepo=* --enablerepo=myrepo-centos,8_sql,8_app perl-DBD-MySQL &>>/install_libs.log

    ## lock
    yum -y install yum-plugin-versionlock &>/dev/null
#    yum versionlock add perl-DBD-MySQL &>/dev/null

    echo -en "Install SSL... "
#    yum install -y libselinux-devel krb5-libs libsepol libcom_err-devel krb5-devel make &>/dev/null
#    yum install -y --disablerepo=* --enablerepo=myrepo-centos openssl-devel openssl openssl-libs &>>/install_0.log
    yum install -y openssl-devel openssl openssl-libs &>>/install_0.log
    if [ $? -eq 0 ];then
        echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0
    else
        echo -e "More details: cat /install_0.log"
        echo -e "\033[1;31m [ERROR] \033[0m\n";tput sgr0;exit
    fi

    echo -e "\n\n\033[1;33mRun process Haveged\n\n\033[0m\n";tput sgr0

    echo -en "Install Haveged... "
    yum -y install haveged &>>/install_0.log
    if [ $? -eq 0 ];then
        echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0
    else
        echo -e "\033[1;31m [ERROR] \033[0m\n";tput sgr0;exit
    fi

    echo -en "Configure Haveged... "
    systemctl enable haveged &>/dev/null
    systemctl start haveged &>/dev/null
    echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0
fi

d=`date`
echo -e ""
echo -en "\033[1;32m$d \033[0m\n"

## Array of packages
package_install_7=(dbus ca-certificates mariadb-libs mariadb-connector-c-config mariadb-connector-c \
    "man" "wget" libxml2 libXpm gmp libicu t1lib "gcc" \
    jailkit libevent \
    aspell libjpeg libvpx libpng freetype readline libxslt tar mc \
    ncurses "make" gd libxslt sudo "perl" \
    sqlite smtpdaemon libedit libacl postgresql unixODBC net-snmp \
    tokyocabinet recode enchant libaio libyaml "which" "rpm" \
    perl-Time-HiRes perl-DBI gnutls \
    ruby ruby-devel rubygem-rdoc rubygem-json gmp-devel \
    libmcrypt net-tools "unzip" rsync webalizer yajl gperftools-devel \
    perl-DBD-MySQL libssh2 \
    brainy-php5 brainy-php5-fpm brainy-php5-modules-base brainy-php5-devel \
    brainy-php5-gd brainy-php5-json brainy-php5-pdo brainy-php5-mbstring brainy-php5-mcrypt brainy-php5-mysql \
    brainy-php5-mbstring brainy-php5-xml brainy-php5-ssh2 \
    brainy-nginx brainy-nginx-all-modules brainy-php5-pgsql brainy-php5-imap \
    php-brainy-imagick \
    brainy-php5-zip brainy-php5-enchant \
    brainy-php5-zendopcache \
    sshpass "openssl" psmisc dmidecode virt-what numactl-libs quota \
    ocl-icd fftw-libs-double \
    libc-client ImageMagick iptables-services "whois" libpq libntlm clucene-core \
    yajl libunwind gperftools-libs \
    openssl-compact-libs \
    policycoreutils xinetd htop brainy-connect bash-completion brainy-ip \
    libcgroup libcgroup-tools ipcalc2 audit-libs \
    shadow-utils GeoIP libnsl ncurses-compat-libs openssh "openssl")

##    shadow-utils GeoIP mecab)

package_rpm_6=(libzip-0.11.2-1.el6.x86_64.rpm \
	libzip-devel-0.11.2-1.el6.x86_64.rpm \
	mhash-0.9.9.9-3.el6.x86_64.rpm \
	mhash-devel-0.9.9.9-3.el6.x86_64.rpm \
	libmcrypt-2.5.8-9.el6.x86_64.rpm \
	libmcrypt-devel-2.5.8-9.el6.x86_64.rpm \
	freetds-0.91-2.el6.x86_64.rpm \
	isppanel-0.1-1.el6.noarch.rpm \
	brainy_httpd_isp-2.2.31-14_isp.el6.x86_64.rpm \
	brainy_php-5.6.14-12.el6.x86_64.rpm \
	ruby-1.9.3.p547-1.el6.x86_64.rpm)

package_install_6=("man" "wget" libmysqlclient16 libxml2-devel libXpm-devel gmp-devel libicu-devel t1lib-devel \
	aspell-devel openssl-devel libjpeg-devel libvpx-devel \
	libpng-devel freetype-devel readline-devel libtidy-devel libxslt-devel \
	libc-client libc-client-devel "openssl" ncurses-devel \
	"make" httpd-devel libxml2-devel gd-devel \
	libc-client-devel libxslt-devel \
	sudo "perl" "mc" \
	pam-devel sqlite-devel smtpdaemon libedit-devel libtool-ltdl-devel systemtap-sdt-devel \
	libacl-devel unixODBC-devel net-snmp-devel \
	tokyocabinet-devel recode-devel libicu-devel enchant-devel libaio-devel libyaml \
	yum-priorities \
	"which" "rpm" perl-Time-HiRes perl-DBI gnutls jailkit \
	apr apr-util "gcc" unrar \
	ruby ruby-devel rubygems sshpass rsync dmidecode virt-what tar "whois" postgresql-libs)

#
func_inst_rpm() {
	local result=0

	for i in $*; do
		echo -en "Install rpm package: $i...\t"
		rpm -Uv --replacepkgs http://core.brainycp.com/src/package/RPMS/x86_64/"$i" &>instal_rpm.log
		if [ $? -eq 0 ]; then
			#no error
			echo -en "\033[1;32m [OK] \033[0m\n"
			tput sgr0
		else
			#error
			echo -e "\033[1;31m [ERROR] \033[0m\n"
			tput sgr0 
			result=1
			break
		fi
	done
	return $result
}

#
func_install_package() {
	local result=0

	for i in $*; do
		echo -en "Install package: $i...\t\t"
		yum -y install "$i" --disablerepo=* --enablerepo=myrepo-centos,BaseOS,AppStream,extras,8_app,8_sql,8_brainy,brainy-python3_sb &>>install_pkg_L0.log
##		yum -y install "$i"  &>>install_0.log
## DEBUG
#echo "Debug Mode[done install config]. Press any key to continue."
#read -s -n 1

		if [ $? -eq 0 ]; then
			#no error
			echo -en "\033[1;32m [OK] \033[0m\n"
			tput sgr0
		else
			#error
			echo -e "\033[1;31m [ERROR] \033[0m\n"
			tput sgr0 
			result=1
			break
		fi
	done
	return $result
}

##
func_prepare_install() {
    cd /tmp
}

##
func_prepare() {
	yum -y erase httpd httpd-tools apr apr-util  &>/prepare_pkg.log
	#yum -y remove mysql* &>>/prepare_pkg.log
	
	cd /tmp
	rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY*

	#
	func_prepare_install

	echo -e "\n   Update ruby...\n\n"
	#Update rubygems
	#gem update --system
	#gem install bundler
	gem install fpm

	mkdir -p /usr/local/brainycp/{classes,plugins,data,tmp,modules,tpl,langs,src/compiled,lib,scripts}
	mkdir -p /var/log/brainy
	slog=/var/log/brainy/install

	HOST=`hostname`
	ANS=`grep "$HOST" /etc/hosts`
	ipaddr=$(hostname -I)
	SHORT=$(hostname -s)
	STRHOSTS=$ipaddr' '$HOST' '$SHORT

	if [ -n "$ANS" ]
	then
	    echo "there is name of vps"
	else
	    echo "$STRHOSTS" >> /etc/hosts
	fi
}

#
func_tar() {
	local result=0

	for i in $*; do
		echo -en "Unpack: $i...  "
		tar xvf "$i" &>/dev/null
		if [ $? -eq 0 ]; then
			#no error
			echo -en "\033[1;32m [OK] \033[0m\n"
			tput sgr0
		else
			#error
			echo -e "\033[1;31m [ERROR] \033[0m\n"
			tput sgr0 
			result=1
			break
		fi
	done
	return $result
}

## DEBUG
#echo "Debug Mode[main]. Press any key to continue."
#read -s -n 1

####
###
#
# main
#
#
    echo -e "\n\n\033[1;33mRun Install process\n\n\033[0m\n";tput sgr0
    /bin/rm -r -f /var/tmp0/core.brainycp.com/
    /bin/rm -f /etc/yum.repos.d/epel.repo &>/dev/null
    yum clean all &>/dev/null

    # polkit
    #yum -y install polkit &>/dev/null
    #systemctl restart polkit

    echo "d /run/php-fpm 755 root root" > /lib/tmpfiles.d/php-fpm.conf
    mkdir -p /var/run/php-fpm
    systemctl daemon-reload

    firewall-cmd --zone=public --add-port=443/tcp --permanent  &>/dev/null
    firewall-cmd --zone=public --add-port=25/tcp --permanent  &>/dev/null
    firewall-cmd --zone=public --add-port=53/tcp --permanent  &>/dev/null
    firewall-cmd --zone=public --add-port=53/udp --permanent  &>/dev/null
    firewall-cmd --zone=public --add-port=8000/tcp --permanent   &>/dev/null
    firewall-cmd --zone=public --add-port=8002/tcp --permanent  &>/dev/null
    firewall-cmd --reload  &>/dev/null

    yum remove firewalld-* -y  &>/dev/null

    # Install the packages
## DEBUG
#echo "Debug Mode[done install config]. Press any key to continue."
#read -s -n 1

    func_install_package ${package_install_7[*]}
    if [ $? -eq 1 ]; then
        echo -e "An error occurred, see the log file /root/install_pkg_L0.log for details. \n\n"
        tput sgr0
        exit 0
    fi

## FIX BUG
yum -y install --disablerepo=* --enablerepo=myrepo-centos,8_sql mecab  &>/dev/null
yum -y install --disablerepo=* --enablerepo=myrepo-centos,8_sql mysql  &>/dev/null
yum -y install yum-plugin-versionlock &>/dev/null
#yum versionlock add mariadb-connector-c-config mariadb-connector-c &>/dev/null
yum versionlock add mecab &>/dev/null



## DEBUG
#echo "Debug Mode[done install packages]. Press any key to continue."
#read -s -n 1

    yum install -y perl-DBI &>>/install_libs.log
    yum install -y --disablerepo=* --enablerepo=myrepo-centos,8_sql,8_app mariadb-libs &>>/install_libs.log
    yum install -y --disablerepo=* --enablerepo=myrepo-centos,8_sql,8_app perl-DBD-MySQL &>>/install_libs.log

    ## lock
    #yum -y install yum-plugin-versionlock &>/dev/null
    #yum versionlock add mariadb-libs &>/dev/null

# Test packages Ls
# Check pakages
echo -en "Download check script... "
wget -t 3 http://core.brainycp.ru/_checkpkg_LsV1.sh  &>/dev/null
if [ $? -eq 0 ]; then
    echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0
else
    echo -e "\033[1;31m [ERROR] \033[0m\n";tput sgr0
    #exit 0
fi

## Check packages
###. ${PWD_L}/_checkpkg_LsV1.sh -u auto

#
mkdir -p  /usr/local/brainycp/src/compiled/brainy/conf/conf.d
mkdir -p  /usr/local/brainycp/compiled/php5/tmp
sed -i "s@short_open_tag = Off@short_open_tag = on@g" /usr/local/brainycp/src/compiled/php5/php.ini
sed -i "s@max_execution_time = 30@max_execution_time = 180@g" /usr/local/brainycp/src/compiled/php5/php.ini
sed -i "s@upload_max_filesize = 2M@upload_max_filesize = 5120M@g" /usr/local/brainycp/src/compiled/php5/php.ini
sed -i "s@max_input_time = 60@max_input_time = 180@g" /usr/local/brainycp/src/compiled/php5/php.ini
sed -i "s@post_max_size = 8M@post_max_size = 5120M@g" /usr/local/brainycp/src/compiled/php5/php.ini

mkdir -p "/usr/local/brainycp/src/compiled/tmp"
echo 'sys_temp_dir = "/usr/local/brainycp/src/compiled/tmp"' >> /usr/local/brainycp/src/compiled/php5/php.ini
#echo 'date.timezone = "Europe/Kiev"' >> /etc/brainy/src/compiled/php5/php.ini

##%echo "Include /etc/brainy/src/compiled/brainy/conf/conf.d/*.conf" >> /etc/brainy/src/compiled/brainy/conf/httpd.conf
##%echo "<FilesMatch \.php$>" >> /etc/brainy/src/compiled/brainy/conf/httpd.conf
##%echo "SetHandler application/x-httpd-php" >> /etc/brainy/src/compiled/brainy/conf/httpd.conf
##%echo "</FilesMatch>" >> /etc/brainy/src/compiled/brainy/conf/httpd.conf


#echo "Abort. Press any key to continue."
#read -s -n 1
#exit 0

# Run install prepare function
func_prepare

echo -e "Unpack the received packets...\n"


# add user
userpass="$(< /dev/urandom tr -dc _A-Z-a-z-0-9 | head -c8)"
groupadd brainyservice &>/dev/null
#useradd  -g  brainyservice -d /brainyservice/ -m brainyservice -s /sbin/nologin  -p $(echo '" . $passgen . "' | openssl passwd -1 -stdin) &>/dev/stdout
useradd  -g  brainyservice -d /dev/null -s /sbin/nologin  brainyservice &>/dev/null
groupadd no_sshgroup &>/dev/null
usermod -G no_sshgroup brainyservice &>/dev/null
mkdir -p /var/log/brainyservice &>/dev/null
chown -R brainyservice.brainyservice /var/log/brainyservice  &>/dev/null

mkdir -p /usr/local/brainycp/src/compiled/tmp/brainyservice/ &>/dev/null
chown -R brainyservice.brainyservice /usr/local/brainycp/src/compiled/tmp/brainyservice/ &>/dev/null
#mkdir -p /usr/local/brainycp

## DEBUG
#echo "Debug Mode[done install packages]. Press any key to continue."
#read -s -n 1


#groupadd brainy &>/dev/null
#useradd -u 12345 -g brainy -d /home/brainy -s /bin/bash -p $(echo brainy | openssl passwd -1 -stdin) brainy
#echo "brainy ALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers
#echo 'Defaults:brainy !requiretty' >> /etc/sudoers

useradd mailnull -u 47 -g mail -s /sbin/nologin -d /var/spool/mqueue &>/dev/null
useradd sysroot -s /sbin/nologin -d /dev/null &>/dev/null

#groupadd -r nginx &>/dev/null
#useradd -r -d /var/lib/nginx -g nginx -s /sbin/nologin -c "Nginx web server" nginx &>/dev/null

echo -en "Download Brainy panel... \t"
rm -r -f /var/tmp0/brainy
wget -t 3 http://core.brainycp.com/stable/dev_arch/$panel_ver/latest.tar.gz -P /var/tmp0/brainy &>/var/log/brainy_isp.log
if [ $? -eq 0 ]; then
		echo -en "\033[1;32m [OK] \033[0m\n"
		tput sgr0
else
		echo -e "\033[1;31m [ERROR] \033[0m\n"
		tput sgr0 
		echo -e "\n\nAn error occurred during the installation panel\n\n"
		echo -e "\n\nMore details /var/log/brainy_isp.log\n\n"
		exit
fi

echo -en "Install Brainy panel... \t"
cd /var/tmp0/brainy
tar xvf latest.tar.gz &>/var/log/brainy_isp.log
if [ $? -eq 0 ]; then
		echo -en "\033[1;32m [OK] \033[0m\n"
		tput sgr0
else
		echo -e "\033[1;31m [ERROR] \033[0m\n"
		tput sgr0 
		echo -e "\n\nAn error occurred during the installation panel\n\n"
		exit
fi

mkdir -p /usr/local/brainycp
/bin/rm -rf  /var/tmp0/brainy/latest.tar.gz
/bin/cp -R -f /var/tmp0/brainy/* /usr/local/brainycp

mkdir -p /etc/brainy
mkdir -p /etc/brainy/tmp
mkdir -p /var/brainycp/data

/bin/cp -R -f /usr/local/brainycp/conf/* /etc/brainy
/bin/cp -R -f /usr/local/brainycp/data/* /var/brainycp/data

/bin/rm -rf  /usr/local/brainycp/conf
/bin/rm -rf  /usr/local/brainycp/data

cd /etc/brainy

echo -e "Update config brainy... \n\n"

upd_to="\$GLOBALS['OS_VERSION'] = \"$get_osname$get_osver\";"
sed -i "/OS_VERSION/c$upd_to" /etc/brainy/globals.php

upd_arch="\$GLOBALS['ARCH_VERSION'] = \"$arch_ver\";"
sed -i "/ARCH_VERSION/c$upd_arch" /etc/brainy/globals.php

if [ $arch_ver == 'x86_64' ];then
    upd_dir="\$GLOBALS['LIB_DIR'] = \"lib64\";"
else
    upd_dir="\$GLOBALS['LIB_DIR'] = \"lib\";"
fi
sed -i "/LIB_DIR/c$upd_dir" /etc/brainy/globals.php


#    echo -e "\n\n\033[1;33mRun process Haveged\n\n\033[0m\n";tput sgr0
echo -e "\n\n\033[1;33mConfigure Brainy Server. \n\n\033[0m\n";tput sgr0

if [ $ver = 8 ];then
mkdir -p /usr/local/brainycp/src/compiled/brainy/ssl
#yes | cp -f /etc/brainy/conf/https.conf /etc/brainy/src/compiled/brainy/conf/httpd.conf
#chkconfig --add brainysqld
fi

#sqlpass="$(< /dev/urandom tr -dc _A-Z-a-z-0-9 | head -c8)"

#echo -en "\nStarting BrainySQL Server... \n"
#cd /usr/local/brainycp/src/compiled/mysql
#./scripts/mysql_install_db --user=root &>/dev/null
#yes | cp -f /etc/brainy/conf/brainy.cnf /etc/brainy/src/compiled/mysql/my.cnf
#service brainysqld start &>install_brainysql.log
#	if [ $? -eq 0 ]; then
#			echo -en "\033[1;32m [OK] \033[0m\n"
#			tput sgr0
#	else
#			echo -e "\033[1;31m [ERROR] \033[0m\n"
#			tput sgr0 
#			exit
#	fi
  

vvirttype="$(get_server_virt_type)"
updd_to="\$GLOBALS['VIRT_TYPE'] = \"$vvirttype\";"
sed -i "/VIRT_TYPE/c$updd_to" /etc/brainy/globals.php

echo "Determing virtualization type... "$vvirttype

#echo "Abort."
#exit 0

yum -y install unzip openssl ntp &>/dev/null
service ntpd restart &>/dev/null

# chmod 755 /usr/local/brainycp/src/compiled/brainy/bin/brainy
sed -i "/memory_limit = 128M/c\memory_limit = 512M" /usr/local/brainycp/src/compiled/php5/php.ini

# echo -en "\nStarting Brainy Server... "
# service brainy start
# 	if [ $? -eq 0 ]; then
# 			echo -en "\033[1;32m [OK] \033[0m\n"
# 			tput sgr0
# 	else
# 			echo -e "\033[1;31m [ERROR] \033[0m\n"
# 			tput sgr0 
# 			exit
# 	fi
# chkconfig brainy on &>/dev/null


#echo "" >> /etc/brainy/conf/brainy.ini
#echo "[brainy_mysql]" >> /etc/brainy/conf/brainy.ini
#echo "root_password=$sqlpass" >> /etc/brainy/conf/brainy.ini

chmod 755  /usr/local/brainycp/src/awstats/awstats.pl
#ip_serv=$(ifconfig | grep 'inet addr:'| grep -v '127.0.0.1' | cut -d: -f2 | awk '{ print $1}' | head -1)

## IP control
ip_serv=$(get_ip_server)
#sed -i "s/#server_addr#/$ip_serv/g" /usr/local/brainycp/tpl/server_control/default.html
cp /usr/local/brainycp/tpl/basic/server_control/default.html /usr/local/brainycp/tpl/basic/server_control/default1.html
sed -i "s/#server_addr#/$ip_serv/g" /usr/local/brainycp/tpl/basic/server_control/default.html
sed -i "s/#server_addr#/$ip_serv/g" /usr/local/brainycp/nolicense.php

mkdir -p /var/www/html
rm -rf /var/www/html/default.html
/bin/cp -f /usr/local/brainycp/tpl/basic/server_control/default.html /var/www/html/index.html

ip_dev=`ip route get 1 | awk '{print $NF;exit}' | xargs`
if [[ "$ip_dev" == 192.168.* ]] || [[ "$ip_dev" == 10.* ]];then
        echo '<!-- NATBRAINY -->' >> /var/www/html/index.html
fi

printf "\nBrainyCP installation proccess is finished. Now it will install necessary server software.\n"
if [ $ver = 8 ];then
    /usr/local/brainycp/src/compiled/php5/bin/php /usr/local/brainycp/ssh/fstab.php &>/var/log/brainy_fstab.log
fi


echo -en "\nStarting Brainy SAPI... "
# service brainyphp-fpm start
systemctl restart brainyphp-fpm
        if [ $? -eq 0 ]; then
                        echo -en "\033[1;32m [OK] \033[0m\n"
                        tput sgr0
        else
                        echo -e "\033[1;31m [ERROR] \033[0m\n"
                        tput sgr0
                        exit
        fi
# chkconfig brainyphp on &>/dev/null
systemctl enable brainyphp-fpm  &>/dev/null

echo -en "\nStarting Brainy Server... "
# service brainyphp-fpm start
systemctl restart nginxb
        if [ $? -eq 0 ]; then
                        echo -en "\033[1;32m [OK] \033[0m\n"
                        tput sgr0
        else
                        echo -e "\033[1;31m [ERROR] \033[0m\n"
                        tput sgr0
                        exit
        fi
# chkconfig brainyphp on &>/dev/null
systemctl enable nginxb  &>/dev/null


# Restart the brainy-connect service
systemctl restart brainy-socket.service
systemctl enable brainy-socket.service &>/dev/null

systemctl stop xinetd &>/dev/null
ln -s /usr/bin/python2 /usr/bin/python  &>/dev/null

## Apache MPM
echo "module=\"Worker\"" > /var/brainycp/data/server_control/mpm
#yum -y install --disablerepo=* --enablerepo=myrepo-centos,base,updates logrotate

find /usr/local/brainycp/ssh/  -type f -name '*.php' | xargs chmod +x
find /usr/local/brainycp/ssh/  -type f -name '*.sh' | xargs chmod +x


## DEBUG
#echo "Debug Mode. Press any key to continue."
#read -s -n 1

#/etc/brainy/src/compiled/php5/bin/php /etc/brainy/ssh/quickinstaller.php -a=install -s=packet_manager2 -p=mysql -v=MySql5.6

#echo "Abort."
#exit 0


# Fix for CORDANA
yum -y install --disablerepo=* --enablerepo=myrepo-centos,8_app libwebp &>/dev/null
yum -y install --disablerepo=* --enablerepo=myrepo-centos,8_app libavdevice &>/dev/null
yum -y install systemd glibc &>>/var/log/brainy_update.log
yum -y install python3 &>>/var/log/brainy_update.log
#yum -y install --disablerepo=* --enablerepo=myrepo-centos,8_app curl &>/dev/null


#rm -f /etc/brainy/ssh/mailserver/clamav.sh &>/dev/null
#rm -f /etc/brainy/ssh/mailserver/dovecot.sh &>/dev/null
#rm -f /etc/brainy/ssh/mailserver/spamassassin.sh &>/dev/null
#wget http://185.181.165.8/v2/dovecot.sh -P /etc/brainy/ssh/mailserver/ &>/dev/null
#wget http://185.181.165.8/v2/clamav.sh -P /etc/brainy/ssh/mailserver/ &>/dev/null
#wget http://core.brainycp.com/v2/spamassassin.sh -P /etc/brainy/ssh/mailserver/ &>/dev/null
#chmod 755 /etc/brainy/ssh/mailserver/clamav.sh &>/dev/null
#chmod 755 /etc/brainy/ssh/mailserver/dovecot.sh &>/dev/null
#chmod 755 /etc/brainy/ssh/mailserver/spamassassin.sh &>/dev/null

######
# run postinstall process
#####
## DEBUG
#echo "Debug Mode[prepare install]. Press any key to continue..."
#read -s -n 1

# Disable automate update dnf
systemctl stop dnf-makecache.service   &>/dev/null
systemctl stop dnf-makecache.timer   &>/dev/null
systemctl disable dnf-makecache.service   &>/dev/null
systemctl disable dnf-makecache.timer  &>/dev/null

echo ""
FILE="/usr/local/brainycp/scripts/postinstall.php"
if [ -f $FILE ]; then
	echo -e "Run postinstall process... \n"
	echo "Setup: $setup \n" &>/var/log/logerror_post.log
	/usr/local/brainycp/src/compiled/php5/bin/php /usr/local/brainycp/scripts/postinstall.php $setup &>>/var/log/logerror_post.log
	if [ $? -eq 0 ]; then
		result=0
		echo -en "\033[1;32m [OK] \033[0m\n"
		tput sgr0
	else
		result=1
		echo -e "\033[1;31m [ERROR] \033[0m\n"
		tput sgr0 
		exit
	fi
fi

yum -y module disable nginx php httpd mysql &>/module.log

# gool correct s-bit
chmod 4111 /usr/bin/sudo
FILE="/usr/sbin/suexec"
if [ -f $FILE ]; then
    chmod 4510 "/usr/sbin/suexec"
fi

yum remove -y openvpn &>/dev/null

#echo "nameserver 8.8.8.8" >> /etc/resolv.conf
yum -y install --disablerepo=* --enablerepo=myrepo-centos,base,updates webalizer &>>/install_0.log
yum -y install --disablerepo=* --enablerepo=myrepo-centos,base,updates sshpass   &>>/install_0.log
yum -y install --disablerepo=* --enablerepo=myrepo-centos,base,updates logrotate  &>>/install_0.log

#rpm -e --nodeps dhclient  &>>/install_0.log

#chmod 755 /usr/local/brainycp/ssh/brainy_mount.sh
chmod +x "/usr/local/brainycp/ssh/brainy_mount.sh"

# start xinetd service
#systemctl restart xinetd &>/dev/null
#systemctl enable xinetd &>/dev/null

#if [ "$netcls" != "network" ];then
#rpm -e --nodeps dhclient  &>>/install_0.log
#echo -en "Prepare configure 1... "
#yum -y install --disablerepo=* --enablerepo=myrepo-centos,base,updates dhclient NetworkManager NetworkManager-tui &>>/install_0.log
#	if [ $? -eq 0 ]; then
#		result=0
#		echo -en "\033[1;32m [OK] \033[0m\n"
#		tput sgr0
#	else
#		result=1
#		echo -e "\033[1;31m [ERROR] \033[0m\n"
#		tput sgr0 
#		exit
#	fi
#fi

#
iptables -A INPUT -p udp ! -s 192.168.1.0/24 --dport 111 -j DROP
iptables -A INPUT -p tcp ! -s 192.168.1.0/24 --dport 111 -j DROP
iptables -A INPUT -p tcp -s 127.0.0.1 --dport 111 -j ACCEPT
iptables-save > /etc/sysconfig/iptables
systemctl enable iptables &>/dev/null


# FIX: FPM-pool
mkdir -p /var/log/php-fpm &>/dev/null
chmod u+s /usr/sbin/sendmail &>/dev/null
chmod u+s /usr/sbin/exim &>/dev/null

# RootKit 
echo -e "\n\n\033[1;33mRootKit Analizer Tools. \n\n\033[0m\n";tput sgr0
#echo -en "Install rkhunter... "
#yum -y install --disablerepo=* --enablerepo=myrepo-centos rkhunter &>>/install_0.log
#	if [ $? -eq 0 ]; then
#		result=0
#		echo -en "\033[1;32m [OK] \033[0m\n"
#		tput sgr0
#	else
#		result=1
#		echo -e "\033[1;31m [ERROR] \033[0m\n"
#		tput sgr0 
#		#exit
#	fi

#echo -en "Install chkrootkit... "
#yum -y install usermode &>>/install_0.log
#yum -y install --disablerepo=* --enablerepo=myrepo-centos chkrootkit &>>/install_0.log
#	if [ $? -eq 0 ]; then
#		result=0
#		echo -en "\033[1;32m [OK] \033[0m\n"
#		tput sgr0
#	else
#		result=1
#		echo -e "\033[1;31m [ERROR] \033[0m\n"
#		tput sgr0 
#		#exit
#	fi

# Configure Analizer
echo -en "Configure RootKit Analizer... "
rkhunter --update &>/dev/null
rkhunter --propupd &>/dev/null
rkhunter --propupd --pkgmgr RPM &>/dev/null
echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0



# Configure key
echo -en "Configure SSL key... "
FQDN=`hostname`
if [ "x${FQDN}" = "x" ]; then
   FQDN=localhost.localdomain
fi

#cat << EOF | openssl req -x509 -nodes -days 365 -newkey rsa:2048 -keyout /etc/brainy/src/ssl/webserver.key -out /etc/brainy/src/ssl/webserver.crt &>/dev/null
#RU
#RU
#SomeCity
#SomeOrganization
#SomeOrganizationalUnit
#${FQDN}
#root@${FQDN}
#EOF

#cat << EOF | openssl req -x509 -nodes -days 365 -newkey rsa:2048 -keyout /etc/brainy/src/ssl/ftp.key -out /etc/brainy/src/ssl/ftp.crt  &>/dev/null
#RU
#RU
#SomeCity
#SomeOrganization
#SomeOrganizationalUnit
#${FQDN}
#root@${FQDN}
#EOF

sed -i 's@$LogFormatString =~ s/\\\"%{Referer}.*@$LogFormatString =~ s/\\\"%\\\{Referer\\\}i\\\"/%refererquot/g;@g' /usr/local/brainycp/src/awstats/awstats.pl
sed -i 's@$LogFormatString =~ s/\\\"%{User-Agent}.*@$LogFormatString =~ s/\\\"%\\\{User-Agent\\\}i\\\"/%uaquot/g;@g' /usr/local/brainycp/src/awstats/awstats.pl
sed -i 's@$LogFormatString =~ s/%{mod_gzip_input_size}.*@$LogFormatString =~ s/%\\\{mod_gzip_input_size\\\}n/%gzipin/g;@g' /usr/local/brainycp/src/awstats/awstats.pl
sed -i 's@$LogFormatString =~ s/%{mod_gzip_output_size}.*@$LogFormatString =~ s/%\\\{mod_gzip_output_size\\\}n/%gzipout/g;@g' /usr/local/brainycp/src/awstats/awstats.pl
sed -i 's@$LogFormatString =~ s/%{mod_gzip_compression_ratio}.*@$LogFormatString =~ s/%\\\{mod_gzip_compression_ratio\\\}n/%gzipratio/g;@g' /usr/local/brainycp/src/awstats/awstats.pl
perl -i -pe  's@\$LogFormatString =~ s\/\\[(]%[{]ratio.*@\$LogFormatString =~ s/\\\(%\\\{ratio\\\}n\\\)/%deflateratio/g;@' /usr/local/brainycp/src/awstats/awstats.pl


echo -en "\033[1;32m [OK] \033[0m\n";tput sgr0

#yum -y install dhclient NetworkManager NetworkManager-tui NetworkManager-wifi NetworkManager-team &>>/install_0.log

yum -y install --disablerepo=* --enablerepo=myrepo-centos,BaseOS,AppStream,extras,8_app,8_sql,8_brainy,brainy-python3_sb rsync   &>>/install_0.log
yum -y install --disablerepo=* --enablerepo=myrepo-centos,BaseOS,AppStream,extras,8_app,8_sql,8_brainy,brainy-python3_sb lftp &>>/install_0.log
yum -y install rclone &>>/install_0.log

#yum -y install httpd-tools --disablerepo=* --enablerepo=myrepo-centos     &>/dev/null
yes | cp -f /etc/brainy/i18n /etc/sysconfig/

if [ "$get_osname" == "centos" ]; then
        mv /var/tmp0/brainy_repos/* /etc/yum.repos.d/ &>/dev/null
fi


/bin/rm -R -f /etc/brainy/ssh &>/dev/null
/bin/rm -R -f /etc/brainy/src &>/dev/null

# do not set for openvz of all stripes
if [ "$vvirttype" != "openvz" ]; then

if [ "$netcls" != "network" ];then
echo "Network flag: $network \n" &>>/installNetwork_0.log
echo -en "Configure Network Manager ($net_service)... \n"
if [[ $network != "" ]];then
	echo -e "  Configure network interface.\n"
        echo -e "  Service NetworkManager is down \n"  &>>/installNetwork_0.log
        #systemctl stop NetworkManager &>>/installNetwork_0.log
        #service NetworkManager stop &>>/installNetwork_0.log

        #systemctl disable NetworkManager  &>>/installNetwork_0.log
        #chkconfig --level 345 NetworkManager off  &>>/installNetwork_0.log

        #systemctl enable network &>>/installNetwork_0.log
        #chkconfig --level 345 network on  &>>/installNetwork_0.log

        #service network restart &>>/installNetwork_0.log
        #systemctl restart network &>>/installNetwork_0.log

        systemctl restart NetworkManager &>>/installNetwork_0.log
        service NetworkManager restart &>>/installNetwork_0.log
        systemctl enable NetworkManager  &>>/installNetwork_0.log

        echo -e "  Service NetworkManager is down\n"
else
	echo -e "  Configure manager interface tools.\n"
        echo -e "  Service NetworkManager is up \n"  &>>/installNetwork_0.log
        systemctl stop network &>>/installNetwork_0.log
        systemctl disable network &>>/installNetwork_0.log

	systemctl enable NetworkManager  &>>/installNetwork_0.log
	systemctl restart NetworkManager  &>>/installNetwork_0.log
        echo -e "  Service NetworkManager is up\n"
fi
fi

else
    echo -e "Network terminated for openVZ\n"

    systemctl disable NetworkManager  &>>/installNetwork_0.log
    chkconfig --level 345 NetworkManager off  &>>/installNetwork_0.log
    systemctl enable network &>>/installNetwork_0.log
    chkconfig --level 345 network on  &>>/installNetwork_0.log
fi

##
## Kernel update params
##
echo -e "\n\n\033[1;33mKernel Update values \n\n\033[0m\n";tput sgr0
echo -n "Level 1... "
# Level 1
sysctl -e -w fs.file-max=286242 &>/dev/null
echo "fs.file-max=286242" >> /etc/sysctl.conf

sysctl -e -w net.ipv4.tcp_keepalive_time=300 &>/dev/null
echo "net.ipv4.tcp_keepalive_time=300" >> /etc/sysctl.conf

sysctl -e -w net.core.somaxconn=4096 &>/dev/null
echo "net.core.somaxconn=4096" >> /etc/sysctl.conf

sysctl -e -w net.core.netdev_max_backlog=4096 &>/dev/null
echo "net.core.netdev_max_backlog=4096" >> /etc/sysctl.conf

sysctl -e -w net.ipv4.tcp_max_syn_backlog=4096 &>/dev/null
echo "net.ipv4.tcp_max_syn_backlog=4096" >> /etc/sysctl.conf

# Level 2
#
# BBR congestion control algorithm (default: cubic)
sysctl -e -w net.ipv4.tcp_congestion_control=bbr &>/dev/null
echo "net.ipv4.tcp_congestion_control=bbr" >> /etc/sysctl.conf

# BBR requires fq for queue management (default: fq_codel)
sysctl -e -w net.core.default_qdisc=fq &>/dev/null
echo "net.core.default_qdisc=fq" >> /etc/sysctl.conf

# Time default value for tcp_fin_timeout connection (default: 60)
sysctl -e -w net.ipv4.tcp_fin_timeout=40 &>/dev/null
echo "net.ipv4.tcp_fin_timeout=40" >> /etc/sysctl.conf

# Disable the gradual speed increase,  useful on variable-speed WANs but not for us (default: 1)
sysctl -e -w net.ipv4.tcp_slow_start_after_idle=0 &>/dev/null
echo "net.ipv4.tcp_slow_start_after_idle=0" >> /etc/sysctl.conf

# Don't cache ssthresh from previous connection (default: 0)
sysctl -e -w net.ipv4.tcp_no_metrics_save=1 &>/dev/null
echo "net.ipv4.tcp_no_metrics_save=1" >> /etc/sysctl.conf

# Avoid MTU black holes (default: 0)
sysctl -e -w net.ipv4.tcp_mtu_probing=1 &>/dev/null
echo "net.ipv4.tcp_mtu_probing=1" >> /etc/sysctl.conf

# Level 3
#
#net.ipv4.ip_nonlocal_bind=1
#net.ipv6.ip_nonlocal_bind=1

sysctl -e -w net.ipv4.ip_nonlocal_bind=1 &>/dev/null
echo "net.ipv4.ip_nonlocal_bind=1" >> /etc/sysctl.conf

sysctl -e -w net.ipv6.ip_nonlocal_bind=1 &>/dev/null
echo "net.ipv6.ip_nonlocal_bind=1" >> /etc/sysctl.conf

# swap
sysctl -e -w vm.swappiness=50 &>/dev/null
echo "vm.swappiness=50" >> /etc/sysctl.conf

# oom_killer disable
sysctl -e -w oom_kill_allocating_task=1 &>/dev/null
echo "oom_kill_allocating_task=1" >> /etc/sysctl.conf

sysctl -e -w kernel.watchdog_thresh=20 &>/dev/null
echo "kernel.watchdog_thresh=20" >> /etc/sysctl.conf

# ipv6
# kernel.watchdog_thresh = 20
# net.ipv6.conf.all.disable_ipv6=0
# net.ipv6.conf.default.disable_ipv6=0

#sysctl -w net.ipv6.conf.all.disable_ipv6=0 &>/dev/null
#echo "net.ipv6.conf.all.disable_ipv6=0" >> /etc/sysctl.conf
#sysctl -w net.ipv6.conf.default.disable_ipv6=0 &>/dev/null
#echo "net.ipv6.conf.default.disable_ipv6=0" >> /etc/sysctl.conf

sysctl -p &>/dev/null

chmod +x /etc/rc.d/rc.local &>/dev/null
chmod 0640 /etc/brainy/mysql &>/dev/null
ln -s /usr/bin/python2 /usr/bin/python  &>/dev/null

#echo "Kernel update values"
for KERNEL in /boot/vmlinuz-*; do
    grubby --update-kernel="$KERNEL" --args="transparent_hugepage=never"
done
echo -e "Done."


# Update Memory Kernel politics 1
/bin/rm -f /etc/cron.hourly/clearcache1 &>/dev/null
touch /etc/cron.hourly/clearcache1 &>/dev/null

echo "#! /bin/bash" > /etc/cron.hourly/clearcache1
echo "" >> /etc/cron.hourly/clearcache1
echo "sync ; echo 1 > /proc/sys/vm/drop_caches" >> /etc/cron.hourly/clearcache1
echo "" >> /etc/cron.hourly/clearcache1
echo "exit 0" >> /etc/cron.hourly/clearcache1

chmod 0755 /etc/cron.hourly/clearcache1 &>/dev/null

#
# Update Memory Kernel politics 2
/bin/rm -f /etc/cron.daily/clearcache2 &>/dev/null
touch /etc/cron.daily/clearcache2 &>/dev/null

echo "#! /bin/bash" > /etc/cron.daily/clearcache2
echo "" >> /etc/cron.daily/clearcache2
echo "sync ; echo 2 > /proc/sys/vm/drop_caches" >> /etc/cron.daily/clearcache2
echo "" >> /etc/cron.daily/clearcache2
echo "exit 0" >> /etc/cron.daily/clearcache2

chmod 0755 /etc/cron.daily/clearcache2 &>/dev/null

# Update new politics
systemctl restart crond &>/dev/null

echo "3.01" > /etc/brainy/inst_version

#FIXME: Bloking
#yum -y install --disablerepo=* --enablerepo=myrepo-centos pyOpenSSL  &>/dev/null
#yum -y install yum-plugin-versionlock &>/dev/null
#yum versionlock add mariadb-connector-c-config mariadb-connector-c &>/dev/null

# postinstall update service
systemctl disable auditd  &>/dev/null

#
# Permanent
#
echo "Determing virtualization type... "$vvirttype
find /var/brainycp/data -type f -exec chmod 640 {} \;

## END 


#rpm -Uv --replacepkgs http://brainyrepo1.brainycp.com/centos/repo/repo-brainy-v3-8.0-1.el8.noarch.rpm
#yum -y install yum-plugin-versionlock &>/dev/null
#yum -y module disable nginx php httpd mysql &>/module.log

#sysctl -e -w vm.nr_hugepages=20 &>/dev/null
#echo "vm.nr_hugepages=20" >> /etc/sysctl.conf
#sysctl -p &>/dev/null
#chmod u+s /usr/sbin/sendmail &>/dev/null
#chmod u+s /usr/sbin/exim &>/dev/null

#yum install -y hugepages &>/dev/null
#systemctl start transparent-huge-pages.service &>/dev/null
#systemctl enable transparent-huge-pages.service &>/dev/null
#sed -i "/SELINUX=enforcing/cSELINUX=disabled" /etc/sysconfig/selinux &> /dev/null

#
# VIRT TYPE
#
#yum clean all &>/dev/null
#yum install -y centos-linux-repos &>/dev/null
#yum -y install virt-what dmidecode &>/dev/null
#sed -i '/\[appstream\]/c\[AppStream\]' /etc/yum.repos.d/CentOS-Linux-AppStream.repo &>/dev/null
#sed -i '/\[baseos\]/c\[BaseOS\]' /etc/yum.repos.d/CentOS-Linux-BaseOS.repo &>/dev/null
#yum clean all &>/dev/null
#rpm -Uv --install http://repo.brainycp.com/centos/repo/repo-brainy-v3-8.0-1.el8.noarch.rpm  &>>/var/log/brainy/install_repo.log
#	rpm -Uv --replacepkgs http://brainyrepo1.brainycp.com/centos/repo/repo-brainy-v3-8.0-1.el8.noarch.rpm &>>/var/log/brainy/install_repo.log
